#include "cs.h"			/*				ENTRY.C		*/
#include "insert.h"
#include "aops.h"
#include "midiops.h"
#include "ugens1.h"
#include "ugens2.h"
#include "ugens3.h"
#include "ugens4.h"
#include "ugens5.h"
#include "ugens6.h"
#include "ugens7.h"
#include "dsputil.h"
#include "ugens8.h"
#include "window.h"
#include "windin.h"
#include "spectra.h"
#include "disprep.h"
#include "soundio.h"
#include "dumpf.h"

#define S	sizeof

void	ihold(), turnoff();
void	assign(), rassign(), aassign();
void	init(), ainit();
void	gt(), ge(), lt(), le(), eq(), ne(), and(), or();
void	conval(), aconval();
void	addkk(), subkk(), mulkk(), divkk();
void	addka(), subka(), mulka(), divka();
void	addak(), subak(), mulak(), divak();
void	addaa(), subaa(), mulaa(), divaa();
void	int1(), frac1();
void	abs1(), exp01(), log01(), sqrt1(), sin1(), cos1();
void	absa(), expa(), loga(), sqrta(), sina(), cosa();
void	dbamp(), ampdb(), aampdb();
void	ftlen();
void	cpsoct(), octpch(), cpspch();
void	pchoct(), octcps(), acpsoct();
void	notnum(), veloc();
void	pchmidi(), pchmidib(), octmidi(), octmidib(), cpsmidi(), cpsmidib();
void	ampmidi(), aftset(), aftouch(), chpress(), pbenset(), pchbend();
void	imidictl(), mctlset(), midictl();
void	linset(), kline(), aline();
void	expset(), kexpon(), expon();
void	lsgset(), klnseg(), linseg();
void	xsgset(), kxpseg(), expseg();
void	lnnset(), klinen(), linen();
void	lnrset(), klinenr(), linenr();
void	evxset(), knvlpx(), envlpx();
void	phsset(), kphsor(), phsor();
void	itable(), itabli();
void	tblset(), ktable(), table(), ktabli(), tabli();
void	ko1set(), kosc1(),  kosc1i();
void	oscset(), koscil(), osckk(), oscka(), oscak(), oscaa();
void	koscli(), osckki(), osckai(), oscaki(), oscaai();
void	foscset(), foscil(), foscili(), losset(), loscil(), adset(), adsyn();
void	fofset(), fof(), pvset(), pvoc();
void	bzzset(), buzz();
void	gbzset(), gbuzz();
void	plukset(), pluck();
void	rndset(), krand(), arand();
void	rhset(), krandh(), randh();
void	riset(), krandi(), randi();
void	porset(), port();
void	tonset(), tone(), atone();
void	rsnset(), reson(), areson();
void	lprdset(), lpread(), lprsnset(), lpreson(), lpfrsnset(), lpfreson();
void	rmsset(), rms(), gainset(), gain(), balnset(), balance();
void	downset(), downsamp(), upsamp();
void	indfset(), interp(), kntegrate(), integrate(), kdiff(), diff();
void	samphset(), ksmphold(), samphold();
void	delset(),  delay(),  del1set(), delay1();
void	delrset(), delayr(), delwset(), delayw();
void	tapset(), deltap(), deltapi();
void	cmbset(), comb(), alpass(), rvbset(), reverb();
void	panset(), pan();
void	sndinset(), soundin();
void	in(),  ins(), inq();
void	out(),  outs(), outs1(), outs2();
void	outq(), outq1(), outq2(), outq3(), outq4();
void	igoto(), kgoto(), icgoto(), kcgoto();
void	timset(), timout();
void	reinit(), rigoto(), rireturn();
void	tigoto(), tival();
void	printv(), dspset(), kdsplay(), dsplay(), fftset(), kdspfft(), dspfft();
void	octdwnset(), koctdown(), octdown(), nocdfset(), noctdft();
void	spadmset(), specaddm(), spdifset(), specdiff();
void	spsclset(), specscal(), sphstset(), spechist(), spfilset(), specfilt();
void	sptrkset(), specptrk(), spsumset(), specsum(), spdspset(), specdisp();

void	xyinset(), xyin(), tempeset(), tempest(), tempset(), tempo();
void    kdmpset(), kdmp2set(), kdmp3set(), kdmp4set();
void    kdump(), kdump2(), kdump3(), kdump4();

/* thread vals, where isub=1, ksub=2, asub=4:
		0 =	1  OR	2  (B out only)
		1 =	1
		2 =		2
		3 =	1  AND	2
		4 =			4
		5 =	1  AND		4
		7 =	1  AND (2  OR	4)			*/
		
/* inarg types include the following:
		m	begins an indef list of iargs (any count)
		n	begins an indef list of iargs (nargs odd)
		o	optional, defaulting to 0
		p	   "		"	1
		q	   "		"	10
		v	   "		"	.5
		j	   "		"	-1
   outarg types include:
		m	multiple outargs (1 to 4 allowed)
   (these types must agree with rdorch.c)			*/

OENTRY opcodlst[] = {
/* opcode   dspace	thread	outarg	inargs	isub	ksub	asub	*/
{ ""									},
{ "instr",  0					 			},
{ "endin",  0								},
{ "$label", S(LBLBLK)							},
{ "=",	    0								},
{ "init",   0	/* base names for later prefixes,suffixes */		},
{ "pchmidib",0								},
{ "octmidib",0								},
{ "cpsmidib",0								},
{ "midictl",0								},
{ "oscil",  0								},
{ "oscili", 0								},
{ "ihold",  S(LINK),	1,	"",	"",	ihold			},
{ "turnoff",S(LINK),	2,	"",	"",	NULL,	turnoff		},
{ "r=",	    S(ASSIGN),	1,	"r",	"i",	rassign			},
{ "i=",	    S(ASSIGN),	1,	"i",	"i",	assign			},
{ "k=",	    S(ASSIGN),	2,	"k",	"k",	NULL,	assign		},
{ "a=",	    S(ASSIGN),	4,	"a",	"x",	NULL,	NULL,	aassign	},
{ "iinit",  S(ASSIGN),	1,	"i",	"i",	init			},
{ "kinit",  S(ASSIGN),	1,	"k",	"i",	init			},
{ "ainit",  S(ASSIGN),	1,	"a",	"i",	ainit			},
{ ">",      S(RELAT),	0,	"B",	"kk",	gt,	gt		},
{ ">=",     S(RELAT),	0,	"B",	"kk",	ge,	ge		},
{ "<",      S(RELAT),	0,	"B",	"kk",	lt,	lt		},
{ "<=",     S(RELAT),	0,	"B",	"kk",	le,	le		},
{ "==",     S(RELAT),	0,	"B",	"kk",	eq,	eq		},
{ "!=",     S(RELAT),	0,	"B",	"kk",	ne,	ne		},
{ "&&",     S(LOGCL),	0,	"B",	"BB",	and,	and		},
{ "||",     S(LOGCL),	0,	"B",	"BB",	or,	or		},
{ ":i",     S(CONVAL),	1,	"i",	"bii",	conval			},
{ ":k",     S(CONVAL),	2,	"k",	"Bkk",	NULL,	conval		},
{ ":a",     S(CONVAL),	4,	"a",	"Bxx",	NULL,	NULL,	aconval	},
{ "addii",  S(AOP),	1,	"i",	"ii",	addkk			},
{ "subii",  S(AOP),	1,	"i",	"ii",	subkk			},
{ "mulii",  S(AOP),	1,	"i",	"ii",	mulkk			},
{ "divii",  S(AOP),	1,	"i",	"ii",	divkk			},
{ "addkk",  S(AOP),	2,	"k",	"kk",	NULL,	addkk		},
{ "subkk",  S(AOP),	2,	"k",	"kk",	NULL,	subkk		},
{ "mulkk",  S(AOP),	2,	"k",	"kk",	NULL,	mulkk		},
{ "divkk",  S(AOP),	2,	"k",	"kk",	NULL,	divkk		},
{ "addka",  S(AOP),	4,	"a",	"ka",	NULL,	NULL,	addka	},
{ "subka",  S(AOP),	4,	"a",	"ka",	NULL,	NULL,	subka	},
{ "mulka",  S(AOP),	4,	"a",	"ka",	NULL,	NULL,	mulka	},
{ "divka",  S(AOP),	4,	"a",	"ka",	NULL,	NULL,	divka	},
{ "addak",  S(AOP),	4,	"a",	"ak",	NULL,	NULL,	addak	},
{ "subak",  S(AOP),	4,	"a",	"ak",	NULL,	NULL,	subak	},
{ "mulak",  S(AOP),	4,	"a",	"ak",	NULL,	NULL,	mulak	},
{ "divak",  S(AOP),	4,	"a",	"ak",	NULL,	NULL,	divak	},
{ "addaa",  S(AOP),	4,	"a",	"aa",	NULL,	NULL,	addaa	},
{ "subaa",  S(AOP),	4,	"a",	"aa",	NULL,	NULL,	subaa	},
{ "mulaa",  S(AOP),	4,	"a",	"aa",	NULL,	NULL,	mulaa	},
{ "divaa",  S(AOP),	4,	"a",	"aa",	NULL,	NULL,	divaa	},
{ "iint",   S(EVAL),	1,	"i",	"i",	int1			},
{ "ifrac",  S(EVAL),	1,	"i",	"i",	frac1			},
{ "iabs",   S(EVAL),	1,	"i",	"i",	abs1			},
{ "iexp",   S(EVAL),	1,	"i",	"i",	exp01			},
{ "ilog",   S(EVAL),	1,	"i",	"i",	log01			},
{ "isqrt",  S(EVAL),	1,	"i",	"i",	sqrt1			},
{ "isin",   S(EVAL),	1,	"i",	"i",	sin1			},
{ "icos",   S(EVAL),	1,	"i",	"i",	cos1			},
{ "kint",   S(EVAL),	2,	"k",	"k",	NULL,	int1		},
{ "kfrac",  S(EVAL),	2,	"k",	"k",	NULL,	frac1		},
{ "kabs",   S(EVAL),	2,	"k",	"k",	NULL,	abs1		},
{ "kexp",   S(EVAL),	2,	"k",	"k",	NULL,	exp01		},
{ "klog",   S(EVAL),	2,	"k",	"k",	NULL,	log01		},
{ "ksqrt",  S(EVAL),	2,	"k",	"k",	NULL,	sqrt1		},
{ "ksin",   S(EVAL),	2,	"k",	"k",	NULL,	sin1		},
{ "kcos",   S(EVAL),	2,	"k",	"k",	NULL,	cos1		},
{ "aabs",   S(EVAL),	4,	"a",	"a",	NULL,	NULL,	absa	},
{ "aexp",   S(EVAL),	4,	"a",	"a",	NULL,	NULL,	expa	},
{ "alog",   S(EVAL),	4,	"a",	"a",	NULL,	NULL,	loga	},
{ "asqrt",  S(EVAL),	4,	"a",	"a",	NULL,	NULL,	sqrta	},
{ "asin",   S(EVAL),	4,	"a",	"a",	NULL,	NULL,	sina	},
{ "acos",   S(EVAL),	4,	"a",	"a",	NULL,	NULL,	cosa	},
{ "idbamp", S(EVAL),	1,	"i",	"i",	dbamp			},
{ "iampdb", S(EVAL),	1,	"i",	"i",	ampdb			},
{ "kdbamp", S(EVAL),	2,	"k",	"k",	NULL,	dbamp		},
{ "kampdb", S(EVAL),	2,	"k",	"k",	NULL,	ampdb		},
{ "aampdb", S(EVAL),	4,	"a",	"a",	NULL,	NULL,	aampdb	},
{ "iftlen", S(EVAL),	1,	"i",	"i",	ftlen			},
{ "ki",	    S(ASSIGN),	1,	"i",	"k",	init			},
{ "icpsoct",S(EVAL),	1,	"i",	"i",	cpsoct			},
{ "ioctpch",S(EVAL),	1,	"i",	"i",	octpch			},
{ "icpspch",S(EVAL),	1,	"i",	"i",	cpspch			},
{ "ipchoct",S(EVAL),	1,	"i",	"i",	pchoct			},
{ "ioctcps",S(EVAL),	1,	"i",	"i",	octcps			},
{ "kcpsoct",S(EVAL),	2,	"k",	"k",	NULL,	cpsoct		},
{ "koctpch",S(EVAL),	2,	"k",	"k",	NULL,	octpch		},
{ "kcpspch",S(EVAL),	2,	"k",	"k",	NULL,	cpspch		},
{ "kpchoct",S(EVAL),	2,	"k",	"k",	NULL,	pchoct		},
{ "koctcps",S(EVAL),	2,	"k",	"k",	NULL,	octcps		},
{ "acpsoct",S(EVAL),	4,	"a",	"a",	NULL,	NULL,	acpsoct	},
{ "notnum", S(MIDIVAL), 1,	"i",	"",	notnum			},
{ "veloc",  S(MIDIVAL), 1,	"i",	"",	veloc			},
{ "pchmidi",S(MIDIVAL), 1,	"i",	"",	pchmidi			},
{ "octmidi",S(MIDIVAL), 1,	"i",	"",	octmidi			},
{ "cpsmidi",S(MIDIVAL), 1,	"i",	"",	cpsmidi			},
{ "ipchmidib",S(MIDIVAL),1,	"i",	"",	pchmidib		},
{ "ioctmidib",S(MIDIVAL),1,	"i",	"",	octmidib		},
{ "icpsmidib",S(MIDIVAL),1,	"i",	"",	cpsmidib		},
{ "kpchmidib",S(MIDIVAL),2,	"k",	"",	NULL,	pchmidib	},
{ "koctmidib",S(MIDIVAL),2,	"k",	"",	NULL,	octmidib	},
{ "kcpsmidib",S(MIDIVAL),2,	"k",	"",	NULL,	cpsmidib	},
{ "ampmidi",S(MIDIAMP), 1,	"i",	"io",	ampmidi			},
{ "aftouch",S(MIDISCL), 3,	"k",	"i",	aftset, aftouch		},
{ "chpress",S(MIDISCL), 3,	"k",	"i",	aftset, chpress		},
{ "pchbend",S(MIDISCL), 3,	"k",	"i",	pbenset,pchbend 	},
{ "imidictl",S(MIDICTL),1,	"i",	"i",	imidictl		},
{ "kmidictl",S(MIDICTL),3,	"k",	"i",	mctlset,midictl 	},
{ "line",   S(LINE),	7,	"s",	"iii",	linset,	kline,	aline	},
{ "expon",  S(EXPON),	7,	"s",	"iii",	expset,	kexpon,	expon	},
{ "linseg", S(LINSEG),  7,	"s",	"iin",	lsgset,	klnseg,	linseg	},
{ "expseg", S(EXPSEG),  7,	"s",	"iin",	xsgset,	kxpseg,	expseg	},
{ "linen",  S(LINEN),	7,	"s",	"xiii",	lnnset,	klinen,	linen	},
{ "linenr", S(LINENR),	7,	"s",	"xiii", lnrset,	klinenr,linenr	},
{ "envlpx", S(ENVLPX),	7,	"s",  "xiiiiiio",evxset,knvlpx,	envlpx	},
{ "phasor", S(PHSOR),	7,	"s",	"xo",	phsset,	kphsor,	phsor	},
{ "itable", S(TABLE),	1,	"i",	"iiooo",itable	 		},
{ "itablei", S(TABLE),	1,	"i",	"iiooo",itabli	 		},
{ "table",  S(TABLE),	7,	"s",	"xiooo",tblset,	ktable,	table	},
{ "tablei", S(TABLE),	7,	"s",	"xiooo",tblset,	ktabli,	tabli	},
{ "oscil1", S(OSCIL1),	3,	"k",	"ikii", ko1set,	kosc1   	},
{ "oscil1i",S(OSCIL1),	3,	"k",	"ikii", ko1set,	kosc1i  	},
{ "oscilkk",S(OSC),	7,	"s",	"kkio",	oscset,	koscil,	osckk	},
{ "oscilka",S(OSC),	5,	"a",	"kaio",	oscset,	NULL,	oscka	},
{ "oscilak",S(OSC),	5,	"a",	"akio",	oscset,	NULL,	oscak	},
{ "oscilaa",S(OSC),	5,	"a",	"aaio",	oscset,	NULL,	oscaa	},
{ "oscilikk",S(OSC),	7,	"s",	"kkio",	oscset,	koscli,	osckki	},
{ "oscilika",S(OSC),	5,	"a",	"kaio",	oscset,	NULL,	osckai	},
{ "osciliak",S(OSC),	5,	"a",	"akio",	oscset,	NULL,	oscaki	},
{ "osciliaa",S(OSC),	5,	"a",	"aaio",	oscset,	NULL,	oscaai	},
{ "foscil", S(FOSC),	5,	"a",  "xkkkkio",foscset,NULL,	foscil	},
{ "foscili",S(FOSC),	5,	"a",  "xkkkkio",foscset,NULL,	foscili	},
{ "loscil", S(LOSC),	5,	"mm", "xkiojoojoo",losset,NULL, loscil	},
{ "adsyn",  S(ADSYN),	5,	"a",	"kkkS",	adset,	NULL,	adsyn	},
{ "pvoc",   S(PVOC),	5,	"a",	"kkSo",	pvset,	NULL,	pvoc	},
{ "fof",    S(FOFS),	5,	"a","xxxkkkkkiiiioo",fofset,NULL,fof	},
{ "buzz",   S(BUZZ),	5,	"a",  "xxkio",  bzzset,	NULL,	buzz	},
{ "gbuzz",  S(GBUZZ),	5,	"a",  "xxkkkio",gbzset,	NULL,	gbuzz	},
{ "pluck",  S(PLUCK),	5,	"a",  "kkiiioo",plukset,NULL,	pluck	},
{ "rand",   S(RAND),	7,	"s",	"xv",	rndset,	krand,	arand	},
{ "randh",  S(RANDH),	7,	"s",	"xxv",	rhset,	krandh,	randh	},
{ "randi",  S(RANDI),	7,	"s",	"xxv",	riset,	krandi,	randi	},
{ "port",   S(PORT),	3,	"k",	"kio",	porset,	port		},
{ "tone",   S(TONE),	5,	"a",	"ako",	tonset,	NULL,	tone	},
{ "atone",  S(TONE),	5,	"a",	"ako",	tonset,	NULL,	atone	},
{ "reson",  S(RESON),	5,	"a",	"akkoo",rsnset,	NULL,	reson	},
{ "areson", S(RESON),	5,	"a",	"akkoo",rsnset,	NULL,	areson	},
{ "lpread", S(LPREAD),	3,	"kkkk",	"kSoo",	lprdset,lpread		},
{ "lpreson",S(LPRESON),	5,	"a",	"a",	lprsnset,NULL,	lpreson	},
{ "lpfreson",S(LPFRESON),5,	"a",	"ak",	lpfrsnset,NULL,	lpfreson},
{ "rms",    S(RMS),	3,	"k",	"aqo",	rmsset,	rms		},
{ "gain",   S(GAIN),	5,	"a",	"akqo",	gainset,NULL,	gain	},
{ "balance",S(BALANCE),	5,	"a",	"aaqo",	balnset,NULL,	balance	},
{ "downsamp",S(DOWNSAMP),3,	"k",	"ao",	downset,downsamp	},
{ "upsamp", S(UPSAMP),	4,	"a",	"k",	NULL,	NULL,	upsamp	},
{ "interp", S(INDIFF),	5,	"a",	"ko",	indfset,NULL,	interp	},
{ "integ",  S(INDIFF),	7,	"s",	"xo",	indfset,kntegrate,integrate},
{ "diff",   S(INDIFF),	7,	"s",	"xo",	indfset,kdiff,	diff	},
{ "samphold",S(SAMPHOLD),7,	"s",	"xxoo",	samphset,ksmphold,samphold},
{ "delay",  S(DELAY),	5,	"a",	"aio",	delset,	NULL,	delay	},
{ "delayr", S(DELAYR),	5,	"a",	"io",	delrset,NULL,	delayr	},
{ "delayw", S(DELAYW),	5,	"",	"a",	delwset,NULL,	delayw	},
{ "delay1", S(DELAY1),	5,	"a",	"ao",	del1set,NULL,	delay1	},
{ "deltap", S(DELTAP),	5,	"a",	"k",	tapset, NULL,	deltap	},
{ "deltapi",S(DELTAP),	5,	"a",	"x",	tapset, NULL,	deltapi	},
{ "comb",   S(COMB),	5,	"a",	"akio",	cmbset,	NULL,	comb	},
{ "alpass", S(COMB),	5,	"a",	"akio",	cmbset,	NULL,	alpass	},
{ "reverb", S(REVERB),	5,	"a",	"ako",	rvbset,	NULL,	reverb	},
{ "pan",    S(PAN),	5,	"aaaa",	"akkioo",panset,NULL,	pan	},
{ "soundin",S(SOUNDIN),	5,	"mmmm",	"Soo",	sndinset,NULL,	soundin	},
{ "in",     S(IN),	4,	"a",	"",	NULL,	NULL,	in	},
{ "ins",    S(INS),	4,	"aa",	"",	NULL,	NULL,	ins	},
{ "inq",    S(INQ),	4,	"aaaa",	"",	NULL,	NULL,	inq	},
{ "out",    S(OUT),	4,	"",	"a",	NULL,	NULL,	out	},
{ "outs",   S(OUTS),	4,	"",	"aa",	NULL,	NULL,	outs	},
{ "outq",   S(OUTQ),	4,	"",	"aaaa",	NULL,	NULL,	outq	},
{ "outs1",  S(OUT),	4,	"",	"a",	NULL,	NULL,	outs1	},
{ "outs2",  S(OUT),	4,	"",	"a",	NULL,	NULL,	outs2	},
{ "outq1",  S(OUT),	4,	"",	"a",	NULL,	NULL,	outq1	},
{ "outq2",  S(OUT),	4,	"",	"a",	NULL,	NULL,	outq2	},
{ "outq3",  S(OUT),	4,	"",	"a",	NULL,	NULL,	outq3	},
{ "outq4",  S(OUT),	4,	"",	"a",	NULL,	NULL,	outq4	},
{ "igoto",  S(GOTO),	1,	"",	"l",	igoto			},
{ "kgoto",  S(GOTO),	2,	"",	"l",	NULL,	kgoto		},
{ "goto",   S(GOTO),	3,	"",	"l",	igoto,	kgoto		},
{ "icgoto", S(CGOTO),	1,	"",	"Bl",	icgoto			},
{ "kcgoto", S(CGOTO),	2,	"",	"Bl",	NULL,	kcgoto		},
{ "gcgoto", S(CGOTO),	3,	"",	"Bl",	icgoto,	kcgoto		},
{ "timout", S(TIMOUT),	3,	"",	"iil",	timset,	timout		},
{ "reinit", S(GOTO),	2,	"",	"l",	NULL,	reinit		},
{ "rigoto", S(GOTO),	1,	"",	"l",	rigoto			},
{ "rireturn",S(GOTO),	1,	"",	"",	rireturn		},
{ "tigoto", S(GOTO),	1,	"",	"l",	tigoto			},
{ "tival",  S(EVAL),	1,	"i",	"",	tival			},
{ "print",  S(PRINTV),	1,	"",	"m",	printv			},
{ "display",S(DSPLAY),	7,	"",	"sioo",	dspset, kdsplay,dsplay	},
{ "dispfft",S(DSPFFT),	7,	"",	"siiooo",fftset,kdspfft,dspfft	},
{ "kdump",  S(KDUMP),	3,	"",	"kSii", kdmpset,kdump		},
{ "kdump2", S(KDUMP2),	3,	"",	"kkSii",kdmp2set,kdump2		},
{ "kdump3", S(KDUMP3),	3,	"",	"kkkSii",kdmp3set,kdump3	},
{ "kdump4", S(KDUMP4),	3,	"",	"kkkkSii",kdmp4set,kdump4	},
{ "octdown",S(OCTDOWN),	7,	"d",	"siio",octdwnset,koctdown,octdown},
{ "noctdft",S(NOCTDFT), 5,	"w",	"diiqooo",nocdfset,NULL,noctdft },
{ "specaddm",S(SPECADDM),5,	"w",	"wwp",  spadmset,NULL,	specaddm},
{ "specdiff",S(SPECDIFF),5,	"w",	"w",    spdifset,NULL,	specdiff},
{ "specscal",S(SPECSCAL),5,	"w",	"wii",  spsclset,NULL,	specscal},
{ "spechist",S(SPECHIST),5,	"w",	"w",    sphstset,NULL,	spechist},
{ "specfilt",S(SPECFILT),5,	"w",	"wi",   spfilset,NULL,	specfilt},
{ "specptrk",S(SPECPTRK),5,	"k",	"wiioooo",sptrkset,NULL,specptrk},
{ "specsum",S(SPECSUM), 5,	"k",	"wo",   spsumset,NULL,	specsum },
{ "specdisp",S(SPECDISP),5,	"",	"wii",  spdspset,NULL,	specdisp},
{ "xyin",   S(XYIN),    3,      "kk",   "iiiiioo",xyinset,xyin          },
{ "tempest",S(TEMPEST), 5,	"k","kiiiiiiiiiop",tempeset,NULL,tempest},
{ "tempo",  S(TEMPO),   3,      "",     "ki",   tempset,tempo           }
};

OENTRY *oplstend = opcodlst + sizeof(opcodlst)/sizeof(OENTRY);
