#include "cs.h"                                        /*  FILOPEN.C    */

#define MAXNAME 128
#define	ERRSIZ	200
#define	WARNMSG	04

char	errmsg[ERRSIZ];	               /* sprintf space for compiling msgs */
static	char	*ssdirpath, *sfdirpath;
        char    *sadirpath, *retfilnam;       /* actual filename returned  */

sssfinit()
{
#ifdef THINK_C
        extern char ssdir_path[], sfdir_path[], sadir_path[];
	if (ssdir_path != NULL && ssdir_path[0] != '\0')
	    ssdirpath = ssdir_path;
	else ssdirpath = NULL;
	if (sfdir_path != NULL && sfdir_path[0] != '\0')
	    sfdirpath = sfdir_path;
	else sfdirpath = NULL;
	if (sadir_path != NULL && sadir_path[0] != '\0')
	    sadirpath = sadir_path;
	else sadirpath = NULL;
#else
	char	*getenv();
	ssdirpath = getenv("SSDIR");
	sfdirpath = getenv("SFDIR");
	sadirpath = getenv("SADIR");
#endif
}

int isfullpath(name)
  char *name;
{
#ifdef THINK_C
	if (strchr(name,':') != NULL)      /* if name already a pathname */
#else
	if (*name == '/' || *name == '.')
#endif
	    return(1);                     /*   return yes  */
	else return(0);
}

char *catpath(path,name)		/*  build a fullpath filename	*/
  char *path, *name;
{
        static char fullname[MAXNAME];
#ifdef THINK_C
        sprintf(fullname,"%s%s%s",path,":",name);
#else
        sprintf(fullname,"%s%s%s",path,"/",name);
#endif
	return(fullname);
}

char *unquote(name)                 /* remove any quotes from a filename   */
  char *name;                       /* also for THINKC rm ./ & cvt / to :  */
{
        static char newname[MAXNAME];
	register char c, *old = name, *new = newname;
	do {
	    if ((c = *old++) != '"') {
#ifdef THINK_C
		if (new == newname && (c == '.' || c == '/'))
		    continue;
	        if (c == '/')  c = ':';
#endif
	        *new++ = c;
	    }
	} while (c);
	return(newname);
}

#ifdef THINK_C
#define RD_OPTS  O_RDONLY
#define WR_OPTS  O_TRUNC | O_CREAT | O_WRONLY | O_BINARY
#else
#define RD_OPTS  O_RDONLY, 0
#define WR_OPTS  O_TRUNC | O_CREAT | O_WRONLY, 0644
#endif

openin(filnam)     /* open a file for reading.  If not fullpath, will search: */
  char *filnam;    /*  current directory, then SSDIR (if defined), then SFDIR */
{                  /*  returns normal fd, also sets a global return filename  */
                   /*  called by sndgetset (for soundin, gen01), and sfopenin */

	char *pathnam = filnam;
	int  infd;

	if (isfullpath(filnam))
	    infd = open(filnam, RD_OPTS);
	else {
	    if ((infd = open(filnam, RD_OPTS)) > 0)
	        goto done;
	    if (ssdirpath != NULL) {
		pathnam = catpath(ssdirpath, filnam);
		if ((infd = open(pathnam, RD_OPTS)) > 0)
		    goto done;
	    }
	    if (sfdirpath != NULL) {
		pathnam = catpath(sfdirpath, filnam);
		infd = open(pathnam, RD_OPTS);
	    }
	    else dies("cannot open %s, SFDIR undefined", filnam);
	}
  done: retfilnam = pathnam;
	return(infd);
}

openout(filnam, dirtyp)  /* open a file for writing.  If not fullpath, then  */
  char *filnam;          /*   dirtyp 1 will put it in the current directory  */
  int  dirtyp;           /*   dirtyp 2 will put it in SFDIR                  */
{                        /*   dirtyp 3 will put it in SFDIR else in cur dir  */
                         /* returns normal fd, & sets global return filename */
                         /* currently called only by sfopenout (dirtyp 3)    */

	char *pathnam = filnam;
	int  outfd;

	if (isfullpath(filnam))
	    outfd = open(filnam, WR_OPTS);
	else switch(dirtyp) {
	case 3:
	case 2: if (sfdirpath != NULL) {
	            pathnam = catpath(sfdirpath, filnam);
		    outfd = open(pathnam, WR_OPTS);
		    break;
		}
	        else if (dirtyp == 2)
		    dies("cannot open %s, SFDIR undefined", filnam);
	        else printf("SFDIR undefined.  using current directory\n");
	case 1: outfd = open(filnam, WR_OPTS);
	        break;
	default: die("openout: illegal dirtyp");
	}
	retfilnam = pathnam;
	return(outfd);
}

void warning(s)
 register char *s;
{
	if (msglevel & WARNMSG)
		printf("WARNING: %s\n", s);
}

void dies(s,t)
 char *s, *t;
{
	sprintf(errmsg,s,t);
	die(errmsg);
}

void die(s)
 char *s;
{
	printf("%s\n",s);
	exit(1);
}
